use glam::IVec2;
use serde::{Deserialize, Serialize};

use crate::Background;

#[derive(Serialize, Deserialize)]
pub(crate) struct Tilemap {
    pub(crate) data: Vec<u16>,
    pub(crate) size: IVec2,
}

impl Tilemap {
    pub(crate) fn from_bg(bg: &Background) -> Self {
        let mut data = vec![0u16; (bg.size.x * bg.size.y) as usize];
        for y in 0..bg.size.y as usize {
            for x in 0..bg.size.x as usize {
                data[x + y * bg.size.x as usize] = bg.tiles[x][y];
            }
        }

        Self {
            data,
            size: bg.size,
        }
    }
}
